libzypp 17.37.10

PtrTypes.h File Reference
`#include <iosfwd>`
`#include <string>`
`#include <zypp/Globals.h>`
`#include <boost/scoped_ptr.hpp>`
`#include <boost/shared_ptr.hpp>`
`#include <boost/weak_ptr.hpp>`
`#include <boost/intrusive_ptr.hpp>`

Go to the source code of this file.

## Classes
struct | zypp::NullDeleter
| shared_ptr custom deleter doing nothing. More...
struct | zypp::rw_pointer::Shared< D >
struct | zypp::rw_pointer::Intrusive< D >
struct | zypp::rw_pointer::Scoped< D >
struct | zypp::RW_pointer< D, DTraits >
| Wrapper for `const` correct access via Smart pointer types. More...
struct | zypp::RWCOW_pointer< D, DTraits >
| RW_pointer supporting 'copy on write' functionality. More...

## Namespaces
namespace | zypp
| Easy-to use interface to the ZYPP dependency resolver.
namespace | zypp::str
| String related utilities and Regular expression matching.
namespace | std
namespace | zypp::rw_pointer
| Don't forgett to provide versions for PtrType and constPtrType, esp.

## Macros
#define | DEFINE_PTR_TYPE(NAME)
| Forward declaration of Ptr types.

## Functions
std::string | zypp::str::form (const char *format,...) __attribute__((format(printf
| Printf style construction of std::string.
template<typename T, typename... Args>
intrusive_ptr< T > | zypp::make_intrusive (Args &&... __args)
template<>
std::ostream & | std::operator<< (std::ostream &str, const zypp::shared_ptr< void > &obj)
template<>
std::ostream & | std::dumpOn (std::ostream &str, const zypp::shared_ptr< void > &obj)

## Macro Definition Documentation

## ◆ DEFINE_PTR_TYPE

#define DEFINE_PTR_TYPE | ( |  | NAME | ) |

Value:
class NAME; \
extern void intrusive_ptr_add_ref( const NAME * ) ZYPP_API; \
extern void intrusive_ptr_release( const NAME * ) ZYPP_API; \
typedef zypp::intrusive_ptr<NAME> NAME##_Ptr; \
typedef zypp::intrusive_ptr<const NAME> NAME##_constPtr;
ZYPP_API
#define ZYPP_API
Definition Globals.h:69

Forward declaration of Ptr types.

Definition at line 639 of file PtrTypes.h.